/*
 * taskview-generic-proxy.h
 *
 * TaskviewGenericProxy
 *
 * Copyright © 2010 Salomon Sickert
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published
 * by the Free Software Foundation; either version 3 of the licence or (at
 * your option) any later version.
 *
 * See the included COPYING file for more information.
 *
 * Authors:
 *    Salomon Sickert <sickert@in.tum.de>
 */

#ifndef __TASKVIEW_GENERIC_PROXY_H__
#define __TASKVIEW_GENERIC_PROXY_H__

#include <glib-object.h>
#include <gio/gio.h>

G_BEGIN_DECLS

#define TASKVIEW_TYPE_GENERIC_PROXY	(taskview_generic_proxy_get_type ())
#define TASKVIEW_GENERIC_PROXY(obj)	(G_TYPE_CHECK_INSTANCE_CAST ((obj), TASKVIEW_TYPE_GENERIC_PROXY, TaskviewGenericProxy))
#define TASKVIEW_GENERIC_PROXY_CLASS(obj)	(G_TYPE_CHECK_CLASS_CAST ((obj), TASKVIEW_TYPE_GENERIC_PROXY, TaskviewGenericProxyClass))
#define TASKVIEW_IS_GENERIC_PROXY(obj)	(G_TYPE_CHECK_INSTANCE_TYPE ((obj), TASKVIEW_TYPE_GENERIC_PROXY))
#define TASKVIEW_IS_GENERIC_PROXY_CLASS(obj)	(G_TYPE_CHECK_CLASS_TYPE ((obj), TASKVIEW_TYPE_GENERIC_PROXY))
#define TASKVIEW_GENERIC_PROXY_GET_CLASS(obj)	(G_TYPE_INSTANCE_GET_CLASS ((obj), TASKVIEW_TYPE_GENERIC_PROXY, TaskviewGenericProxyClass))

typedef struct _TaskviewGenericProxy TaskviewGenericProxy;
typedef struct _TaskviewGenericProxyClass TaskviewGenericProxyClass;
typedef struct _TaskviewGenericProxyPrivate TaskviewGenericProxyPrivate;

struct _TaskviewGenericProxy
{
  GObject parent;
  TaskviewGenericProxyPrivate *priv;
};

struct _TaskviewGenericProxyClass
{
  GObjectClass parent_class;
};

GType taskview_generic_proxy_get_type (void);

/* C Wrapper */

gchar * taskview_generic_proxy_get_icon (TaskviewGenericProxy *self);
gchar * taskview_generic_proxy_get_description (TaskviewGenericProxy *self);
gchar * taskview_generic_proxy_get_details (TaskviewGenericProxy *self);
gint    taskview_generic_proxy_get_state (TaskviewGenericProxy *self);
gint    taskview_generic_proxy_get_progress (TaskviewGenericProxy *self);
gint    taskview_generic_proxy_get_remaining_time (TaskviewGenericProxy *self);
gint64  taskview_generic_proxy_get_creation_time (TaskviewGenericProxy *self);
gint64  taskview_generic_proxy_get_finished_time (TaskviewGenericProxy *self);

void taskview_generic_proxy_resume (TaskviewGenericProxy *view);
void taskview_generic_proxy_pause (TaskviewGenericProxy *view);
void taskview_generic_proxy_cancel (TaskviewGenericProxy *view);
void taskview_generic_proxy_view (TaskviewGenericProxy *view);

G_END_DECLS

#endif
